=== debian/changelog ===
gnss-sdr (0.0.9-5build3) bionic; urgency=medium

  * No-change rebuild against libuhd003.010.003

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 10 Feb 2018 01:19:45 +0000

gnss-sdr (0.0.9-5build2) bionic; urgency=medium

  * No-change rebuild for armadillo soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 16 Nov 2017 16:10:58 +0000

gnss-sdr (0.0.9-5build1) bionic; urgency=medium

  * No-change rebuild against boost1.65.1

 -- Jeremy Bicha <jbicha@ubuntu.com>  Sun, 29 Oct 2017 12:03:40 -0400

gnss-sdr (0.0.9-5) unstable; urgency=medium

  * Standards-Version updated to 4.0.0
  * Migrated from experimental to unstable

 -- Carles Fernandez <carles.fernandez@cttc.es>  Mon, 03 Jul 2017 22:08:24 +0200

gnss-sdr (0.0.9-4) experimental; urgency=medium

  * Set compat file value to 10, re-enabling parallel building (Closes: #860090)

 -- Carles Fernandez <carles.fernandez@cttc.es>  Tue, 11 Apr 2017 18:10:14 +0200

gnss-sdr (0.0.9-3) experimental; urgency=medium

  * Compat level updated to 10
  * Removed minimum versions in control already available in oldstable
  * libarmadillo-dev minimum version updated to >= 1:5.300.0 due to interp1
  * Added comment on why auto_test is disabled
  * dh is called without --parallel (it is now the default) and without
    --builddirectory=build (which was useless)
  * Thanks to Gianfranco Costamagna for spotting these issues

 -- Carles Fernandez <carles.fernandez@cttc.es>  Mon, 10 Apr 2017 20:27:31 +0200

gnss-sdr (0.0.9-2) experimental; urgency=medium

  * Removed libc6, dpkg-dev and libstdc++6 from build-dependencies
    since dependencies on build-essential binary packages can be omitted

 -- Carles Fernandez <carles.fernandez@cttc.es>  Sat, 08 Apr 2017 12:13:01 +0200

gnss-sdr (0.0.9-1) experimental; urgency=medium

  * First release of upstream version 0.0.9
  * Added python-mako and python-six to build-dependencies required volk_gnsssdr

 -- Carles Fernandez <carles.fernandez@cttc.es>  Fri, 07 Apr 2017 16:31:42 +0200
