=== debian/control ===
Source: gnss-sdr
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Hamradio Maintainers <debian-hams@lists.debian.org>
Uploaders: Carles Fernandez <carles.fernandez@cttc.es>
Section: hamradio
Priority: optional
Build-Depends: debhelper (>= 10),
               cmake,
               libboost-dev,
               libboost-date-time-dev,
               libboost-system-dev,
               libboost-filesystem-dev,
               libboost-thread-dev,
               libboost-serialization-dev,
               libboost-chrono-dev,
               libboost-program-options-dev,
               libboost-test-dev,
               libuhd-dev (>= 3.7),
               gnuradio-dev (>> 3.7.8),
               gr-osmosdr,
               liblog4cpp5-dev,
               libarmadillo-dev (>= 1:5.300.0),
               liblapack-dev,
               libblas-dev,
               libgnutls28-dev,
               libgflags-dev,
               libgoogle-glog-dev (>= 0.3.3),
               libgtest-dev (>= 1.7),
               python-mako,
               python-six
Standards-Version: 4.0.0
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-hamradio/gnss-sdr.git
Vcs-Git: https://anonscm.debian.org/git/pkg-hamradio/gnss-sdr.git
Homepage: http://gnss-sdr.org

Package: gnss-sdr
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Global navigation satellite systems software defined receiver
 Global Navigation Satellite Systems receiver defined by software.
 It performs all the signal processing from raw signal samples up to the
 computation of the Position-Velocity-Time solution, including
 code and phase observables. It is able to work with raw data files or,
 if there is computational power enough, in real time with suitable
 radiofrequency front-ends. This software is mainly developed at CTTC
 (Centre Tecnologic de Telecomunicacions de Catalunya, http://www.cttc.es)
 with contributions from around the world.
 More info at http://gnss-sdr.org
