=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- -DENABLE_PACKAGING=ON -DENABLE_OSMOSDR=ON

# Auto test override due to an upstream bug in QA code. Developer team informed.
# will be fixed in next upstream release

override_dh_auto_test:

#get-orig-source:
#	. debian/get-orig-source
